<?php
class Util {
	
	function rewrite($name) {
		return $name = str_replace(array(' '), '-', $name);
	}
	
	function fazLink($name, $url, $class = '', $prefix = '') {
		return "<a href='{$url}' class='{$class}'>{$name}</a>";
	}
	
	/**
	 * Retorna a cidade/regio de acordo
	 * com o IP informado
	 * 
	 * A base de dados
	 * @param string $ip
	 */
	function getCidadeGeoIP($ip) {
		include_once '../include/geoipcity.inc';
		include_once '../include/geoipregionvars.php';
		$gi = geoip_open(GEOIP, GEOIP_STANDARD);
		$record = geoip_record_by_addr($gi,"{$ip}");
		$cidade = '';
		if ($record) {
			$cidade = "{$record->city} / {$GEOIP_REGION_NAME[$record->country_code][$record->region]} / {$record->country_name}";
		} else {
			$cidade = 'LOCAL NO IDENTIFICADO!';
		}
		return $cidade;
	}
	
	function enviaEmail($FROM_NAME, $FROM_EMAIL, $TO_NAME, $TO_EMAIL, $SUBJECT, $MESSAGE, $IS_HTML = false, $CCOPY = false, $CONFIRM = true, $SENDGRID = false) {
		require_once ('class.phpmailer.php');
		$mail = new PHPMailer();
		$mail->IsSMTP();
		$mail->SMTPAuth = true;
		$mail->Port = 587;
		$mail->Host = 'mail.guiadocalcado.com';
		$mail->Username = 'webmaster@guiadocalcado.com';
		$mail->Password = '@ineo11';
		
		if ($SENDGRID) {
			$mail->Port = 587;
			$mail->Host = 'smtp.sendgrid.net';
			$mail->Username = 'registro@ineosistemas.com.br';
			$mail->Password = 'Ineo2012';
		}
		
		// Aqui algumas informaes que sero enviadas no cabealho do email
		$mail->From = $FROM_EMAIL; // Email de quem envia o email
		$mail->FromName = $FROM_NAME; // Nome de quem envia o email
		$mail->AddAddress($TO_EMAIL, $TO_NAME); // Endereo e nome de quem vai receber o email, o nome  opcional
		if ($CCOPY === true) { 
			$mail->AddBCC('webmaster@guiadocalcado.com', 'Webmaster | Guia do Calado'); 
		}
		$mail->AddReplyTo('naoresponder@guiadocalcado.com', 'NO RESPONDER | Guia do Calado'); // Email e nome que ser utilizado quando a pessoa responder este email
		
		if ($CONFIRM === true) { 
			$mail->ConfirmReadingTo = 'webmaster@guiadocalcado.com';
		}

		$mail->WordWrap = 100; // quebra linha sempre que uma linha atingir 50 caracteres
		$mail->IsHTML($IS_HTML); // ajusto envio do email no formato HTML
		
		$mail->Subject = $SUBJECT; // Aqui colocar o assunto do email
		$mail->Body = $MESSAGE; 
		//$mail->AltBody = $mensagem;
		
		if(!$mail->Send()) {
			//echo "Mensagem n&atilde;o pode ser enviada. <p>";
			//return  "Erro: " . $mail->ErrorInfo;
			return false;
			//exit;
		} else {
			return true;
		}
		
	}
	
	public function getListaFromTable($table, $field, $params = '', $where = '') {
		$objeto = new $table;
		$_where = (!empty($where)) ? "WHERE {$where}" : '';
		$letras = $objeto->retrieveByQuery("SELECT DISTINCT UPPER(LEFT({$field},1)) as letters FROM {$table} {$_where} ORDER BY letters", false);
		$getLetra = (isset($_GET['letra'])) ? $_GET['letra'] : 'tudo';
		if ($letras) {
		?>
		<div style="margin-left: 5px; padding: 5px;">
			<a href="?<?php echo $params; ?>&letra=tudo"><?php echo ($getLetra == 'tudo') ? '<span class="destaque">TUDO</span>' : 'TUDO'; ?></a> &nbsp;&bull;&nbsp;
		<?php
			$total = count($letras);
			$x = 1;
			foreach ($letras as $letra) {
				if ($getLetra == $letra->letters) { 
		?>
				<span class="destaque"><?php echo $letra->letters; ?></span>
		<?php
				} else {
		?>
				<a href="?<?php echo $params; ?>&letra=<?php echo $letra->letters; ?>"><?php echo $letra->letters; ?></a>
		<?php
				}
				$x++;
				if ($x <= $total) {
		?>
				&nbsp;&bull;&nbsp;
		<?php
				}
			}
		?>
		</div>
		<?php
		} else {
			echo '<div style="margin-left: 10px; padding: 5px;">Nenhum registro encontrado</div>';
		}
	}
	
	function createDir($path_dir, $mode = 0775) {
		if (!file_exists($path_dir)) {
			if (mkdir($path_dir, $mode, true)) {
				return true;
			} else {
				return false;
			}
		}
	}
	
	function retira_acentos( $texto ) {
		$array1 = array(   "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "", "" );
		$array2 = array(   "a", "a", "a", "a", "a", "e", "e", "e", "e", "i", "i", "i", "i", "o", "o", "o", "o", "o", "u", "u", "u", "u", "c", "A", "A", "A", "A", "A", "E", "E", "E", "E", "I", "I", "I", "I", "O", "O", "O", "O", "O", "U", "U", "U", "U", "C" );
		return str_replace( $array1, $array2, $texto );
	}
	
	function rename($nome) {
		$name = self::retira_acentos($nome);
		$chars = array('\'', ':', '!', ',', '&', '#', '.', '\'', '');			
		$name = str_replace($chars, "", $name);
		$name = str_replace(array(' ', '/'), "_", $name);
		return $name;
	}
	
	/**
	 * Create image temp
	 *
	 * @param array $file
	 * @param String $target
	 * @param int $width
	 * @return boolean (true/false)
	 *
	 * ex: createImageTemp($_FILES['id_name'], '/image/', 'home.jpg' 150);
	 *
	 */
	function createImage($file, $target, $name, $width, $quality=85, $crop=false, $crop_ratio=1) {
		//$extension = substr($file['name'], 0 -3);exit;
		//$extension = (strtolower($extension) == 'jpg') ? 'jpeg' : strtolower($extension);
		$image_function = "imagecreatefromjpeg";
		if (($pic_im = $image_function($file)) !== false) {
			# Create the image
			self::resize($pic_im, $target.$name, $width, $quality, $crop, $crop_ratio);
			return true;
		} else {
			return false;
		}
		imagedestroy($pic_im);
	}
	
	/**
	 * resize
	 *
	 * @param unknown_type $src_im
	 * @param unknown_type $dpath
	 * @param unknown_type $maxd
	 * @param unknown_type $quality
	 * @param unknown_type $crop
	 * @param unknown_type $crop_ratio
	 */
	function resize(&$src_im, $dpath, $maxd, $quality=85, $crop=false, $crop_ratio=1) {
		$src_width = imagesx($src_im);
		$src_height = imagesy($src_im);
		$src_ratio = $src_width / $src_height;
		$src_w = $src_width;
		$src_h = $src_height;
		$src_x = 0;
		$src_y = 0;
	
		if ($crop) {
			if ($src_ratio > $crop_ratio) {
				$src_h = $src_height;
				$src_w = round($src_h * $crop_ratio);
				if ($src_h > $src_w) {
					$dst_h = ($src_h > $maxd) ? $maxd : $src_h;
					$dst_w = round($dst_h * $crop_ratio);
				} else {
					$dst_w = ($src_w > $maxd) ? $maxd : $src_w;
					$dst_h = round($dst_w / $crop_ratio);
				}
				$src_x = round(($src_width - $src_w) / 2);
			} else {
				$src_w = $src_width;
				$src_h = round($src_w / $crop_ratio);
				if ($src_w > $src_h) {
					$dst_w = ($src_w > $maxd) ? $maxd : $src_w;
					$dst_h = round($dst_w / $crop_ratio);
				} else {
					$dst_h = ($src_h > $maxd) ? $maxd : $src_h;
					$dst_w = round($dst_h * $crop_ratio);
				}
				$src_y = round(($src_height - $src_h) / 2);
			}
		} else {
			if ($src_width > $maxd || $src_height > $maxd) {
				if ($src_width > $src_height) {
					$dst_w = $maxd;
					$dst_h = floor($src_height * ($maxd / $src_width));
				} else {
					$dst_h = $maxd;
					$dst_w = floor($src_width * ($maxd / $src_height));
				}
			} else {
				$dst_w = $src_width;
				$dst_h = $src_height;
			}
		}
	
		$dst_im = imagecreatetruecolor($dst_w, $dst_h);
		imagecopyresampled($dst_im, $src_im, 0, 0, $src_x, $src_y, $dst_w, $dst_h, $src_w, $src_h);
		imagejpeg($dst_im, $dpath, $quality);
		imagedestroy($dst_im);
	}
	
	/**
	 * isImage
	 * 2009-04-23 - Jeff
	 * @param path/file $filename
	 * @return true/false
	 *
	 * ex: isImage($_FILES['teste']['tmp_name']);
	 */
	function isImage($filename) {
		if (@getimagesize($filename)) {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * renameFile
	 *
	 * @param $_FILES['x'] $filedata
	 * @return string
	 */
	function renameFile($filedata) {
		return ereg_replace("[^a-zA-Z0-9_.]", '_', $filedata['name']);
	}
	
	/**
	 * Enter description here...
	 *
	 * @param $_FILES['x_name'] $file
	 * @param string $types
	 * @return bool (true/false);
	 *
	 * ex: checkExtensionFile($_FILES['x_name'], 'video/x-flv,video/mp4');
	 */
	function checkExtensionFile(&$file, $types) {
			
		// Check SO
		$so = substr(getcwd(), 0, 1);
		$finfo = ($so == 'C') ? finfo_open(FILEINFO_MIME,"C:/wamp/bin/php/php5.2.9-1/extras/magic") : finfo_open(FILEINFO_MIME);
		$content_type = finfo_file($finfo, "{$file['tmp_name']}");
		$allowed_mimetypes = explode(",",$types);
			
		//print_r($content_type);
		//echo "<br><br>";
		//print_r($allowed_mimetypes);
			
		if(in_array($content_type, $allowed_mimetypes)) {
			return true;
		} else {
			return false;
		}
			
	}
	
	function recursive_remove_directory($directory, $empty=FALSE)
	{
		// if the path has a slash at the end we remove it here
		if(substr($directory,-1) == '/')
		{
			$directory = substr($directory,0,-1);
		}
	
		// if the path is not valid or is not a directory ...
		if(!file_exists($directory) || !is_dir($directory))
		{
			// ... we return false and exit the function
			return FALSE;
	
			// ... if the path is not readable
		}elseif(!is_readable($directory))
		{
			// ... we return false and exit the function
			return FALSE;
	
			// ... else if the path is readable
		}else{
	
			// we open the directory
			$handle = opendir($directory);
	
			// and scan through the items inside
			while (FALSE !== ($item = readdir($handle)))
			{
				// if the filepointer is not the current directory
				// or the parent directory
				if($item != '.' && $item != '..')
				{
					// we build the new path to delete
					$path = $directory.'/'.$item;
	
					// if the new path is a directory
					if(is_dir($path))
					{
						// we call this function with the new path
						self::recursive_remove_directory($path);
	
						// if the new path is a file
					}else{
						// we remove the file
						unlink($path);
					}
				}
			}
			// close the directory
			closedir($handle);
	
			// if the option to empty is not set to true
			if($empty == FALSE)
			{
				// try to delete the now empty directory
				if(!rmdir($directory))
				{
					// return false if not possible
					return FALSE;
				}
			}
			// return success
			return TRUE;
		}
	}
	
}